Bug 441707 - ADMA problems with sata_nv
Summary: ADMA problems with sata_nv
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel
Version: 4.6
Hardware: All
OS: Linux
medium
medium
Target Milestone: rc
: ---
Assignee: David Milburn
QA Contact: Martin Jenner
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: RHEL4u8_relnotes 461304
TreeView+ depends on / blocked
 
Reported: 2008-04-09 16:14 UTC by Bryn M. Reeves
Modified: 2018-10-20 00:17 UTC (History)
4 users (show)

(edit)
Previously, the Automatic Direct Memory Access (ADMA) mode was enabled by default in the sata_nv driver. Consequently, device errors and timeouts may have been encountered with some devices that utilize the sata_nv driver. With this update, ADMA mode is now disabled by default, which resolves this issue.
Clone Of:
(edit)
Last Closed: 2009-05-18 19:29:10 UTC


Attachments (Terms of Use)
Disable ADMA for sata_nv (952 bytes, patch)
2008-04-09 16:14 UTC, Bryn M. Reeves
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2009:1024 normal SHIPPED_LIVE Important: Red Hat Enterprise Linux 4.8 kernel security and bug fix update 2009-05-18 14:57:26 UTC

Description Bryn M. Reeves 2008-04-09 16:14:01 UTC
Description of problem:
Current RHEL4 sata_nv code enables ADMA mode:

    drivers/ata/sata_nv.c:
    MODULE_DEVICE_TABLE(pci, nv_pci_tbl);
    MODULE_VERSION(DRV_VERSION);

    static int adma_enabled = 1;

This has been reverted upstream in the libata-devel tree in commit
80734d899a4337a1a12164dc22edec5ee45bfb73:

    Continues to have open issues, and engineering support is extremely 
    difficult to come by, according to fellow NVIDIA engineers.

    Signed-off-by: Jeff Garzik <jgarzik@redhat.com>

There are reports of problems including spurious NMIs when using the driver in
ADMA mode.

Version-Release number of selected component (if applicable):
2.6.9-67.0.7.EL

How reproducible:
Sometimes - hardware & use dependent

Steps to Reproduce:
In some cases just reading a drive via:

dd if=/dev/sdX of=/dev/null bs=1M
  
Actual results:
ata4: CPB flags CMD err, flags=0x11
ata4: EH in ADMA mode, notifier 0x0 notifier_error 0x0 gen_ctl 0x1501000 status
0x400
<snip>
ata4: CPB 29: ctl_flags 0x1f, resp_flags 0x1
ata4: CPB 30: ctl_flags 0x1f, resp_flags 0x1
ata4: Resetting port
ata4.00: exception Emask 0x0 SAct 0x3 SErr 0x0 action 0x2 frozen
ata4.00: cmd 60/00:00:00:87:8d/01:00:04:00:00/40 tag 0 cdb 0x0 data 131072 in
        res 41/00:00:00:87:8d/00:00:00:00:00/40 Emask 0x1 (device error)
ata4.00: cmd 61/08:08:4f:00:d0/00:00:1b:00:00/40 tag 1 cdb 0x0 data 4096 out
        res 40/00:00:00:00:00/00:00:00:00:00/00 Emask 0x4 (timeout)
SCSI device sdb: 976773168 512-byte hdwr sectors (500108 MB)
SCSI device sdb: drive cache: write back
ata4: CPB flags CMD err, flags=0x11
ata4: EH in ADMA mode, notifier 0x0 notifier_error 0x0 gen_ctl 0x1501000 status
0x400
ata4: CPB 0: ctl_flags 0x1f, resp_flags 0x2
ata4: CPB 1: ctl_flags 0x1f, resp_flags 0x11
<snip>
ata4: CPB 30: ctl_flags 0x1e, resp_flags 0x1
ata4: Resetting port
ata4.00: exception Emask 0x0 SAct 0x3 SErr 0x0 action 0x2 frozen
ata4.00: cmd 61/10:00:cf:33:00/00:00:00:00:00/40 tag 0 cdb 0x0 data 8192 out
        res 40/00:00:00:87:8d/00:00:00:00:00/40 Emask 0x4 (timeout)
ata4.00: cmd 60/00:08:00:87:8d/01:00:04:00:00/40 tag 1 cdb 0x0 data 131072 in
        res 41/00:00:cf:33:00/00:00:00:00:00/40 Emask 0x1 (device error)
SCSI device sdb: 976773168 512-byte hdwr sectors (500108 MB)
SCSI device sdb: drive cache: write back
ata4: CPB flags CMD err, flags=0x11
Uhhuh. NMI received. Dazed and confused, but trying to continue
You probably have a hardware problem with your RAM chips 

Expected results:
dd completes without error

Comment 1 Bryn M. Reeves 2008-04-09 16:14:01 UTC
Created attachment 301838 [details]
Disable ADMA for sata_nv

Comment 3 Bryn M. Reeves 2008-04-09 16:33:15 UTC
Problem can also be worked around via adma=0 in modprobe.conf

Comment 4 Bryn M. Reeves 2008-04-17 16:00:37 UTC
*** Bug 442906 has been marked as a duplicate of this bug. ***

Comment 6 RHEL Product and Program Management 2008-09-03 13:15:26 UTC
Updating PM score.

Comment 7 RHEL Product and Program Management 2008-09-22 21:44:52 UTC
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.

Comment 9 Vivek Goyal 2008-11-05 13:56:42 UTC
Committed in 78.17.EL . RPMS are available at http://people.redhat.com/vgoyal/rhel4/

Comment 12 David Milburn 2009-01-27 22:57:26 UTC
Release note added. If any revisions are required, please set the 
"requires_release_notes" flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

New Contents:
Cause: ADMA mode is enabled by default in sata_nv
driver.

Consequence: Possible device errors and timeouts
when ADMA mode is enabled in sata_nv driver.

Fix: Disable ADMA mode by default.

Result: sata_nv driver functions properly with
various types of drives.

Comment 15 Ryan Lerch 2009-02-24 01:54:20 UTC
Release note updated. If any revisions are required, please set the 
"requires_release_notes"  flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

Diffed Contents:
@@ -1,10 +1 @@
-Cause: ADMA mode is enabled by default in sata_nv
+Previously, the Automatic Direct Memory Access (ADMA) mode was enabled by default in the sata_nv driver. Consequently, device errors and timeouts may have been encountered some devices that utilize the sata_nv driver. With this update, ADMA mode is now disabled by default, which resolves this issue.-driver.
-
-Consequence: Possible device errors and timeouts
-when ADMA mode is enabled in sata_nv driver.
-
-Fix: Disable ADMA mode by default.
-
-Result: sata_nv driver functions properly with
-various types of drives.

Comment 17 David Milburn 2009-02-24 14:23:29 UTC
Release note updated. If any revisions are required, please set the 
"requires_release_notes"  flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

Diffed Contents:
@@ -1 +1 @@
-Previously, the Automatic Direct Memory Access (ADMA) mode was enabled by default in the sata_nv driver. Consequently, device errors and timeouts may have been encountered some devices that utilize the sata_nv driver. With this update, ADMA mode is now disabled by default, which resolves this issue.+Previously, the Automatic Direct Memory Access (ADMA) mode was enabled by default in the sata_nv driver. Consequently, device errors and timeouts may have been encountered with some devices that utilize the sata_nv driver. With this update, ADMA mode is now disabled by default, which resolves this issue.

Comment 20 Chris Ward 2009-05-05 13:55:57 UTC
Any updates here? Has this issue been resolved in the RHEL 4.8 Beta? later kernel?

Comment 22 errata-xmlrpc 2009-05-18 19:29:10 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1024.html


Note You need to log in before you can comment on or make changes to this bug.